﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	
	Private cvs As Canvas
	Private mLbl As Label
	Private su As StringUtils
	
	Private mParent As Panel
	Private mLeft, mTop, mWidth, mHeight As Int
	Private mText As String
	
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	mLbl.Initialize("mLbl")
	
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	mLeft = mBase.Left
	mTop = mBase.Top
	mWidth = mBase.Width
	mHeight = mBase.Height
	mText = Lbl.Text
	Dim p As Panel
   	p.Initialize("p")
   	p.Color = Colors.Transparent
   	mBase.AddView(p, 0, 0, mBase.Width, mBase.Height)
	Init(Array As Object(0,0,0,0))

End Sub
'Adds an AutoTextSizeEditText custom view onto the given Parent view
'Parent = parent object, an Activity or a Panel
'Left, Top, Width, Height position and dimension of the AutoTextSizeEditText
'Text = text to display
Public Sub AddToParent(Parent As Panel, Left As Int, Top As Int, Width As Int, Height As Int, Text As String, arrPadding() As Object)
	mParent = Parent
	mLeft = Left
	mTop = Top
	mWidth = Width
	mHeight = Height
	mText = Text
	
	mBase.Initialize("")
	mParent.AddView(mBase, mLeft, mTop, mWidth, mHeight)

	Init(arrPadding)
End Sub

Private Sub Init(arrPadding() As Object)
	Private bmp As Bitmap
	Dim r As Reflector
	
	bmp.InitializeMutable(1, 1) 'ignore
	cvs.Initialize2(bmp)

	Private cdw As ColorDrawable
	cdw.Initialize(Colors.Transparent, 0)
	mBase.Background = cdw
		
	'mLbl.Initialize("mLbl")
	mLbl.Text = mText

	r.Target = mLbl
	r.RunMethod4("setPadding", arrPadding, Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))
	r.RunMethod4("setIncludeFontPadding", Array As Object(False), Array As String("java.lang.boolean"))

	mBase.AddView(mLbl, 0, 0, mWidth, mHeight)
	
	setText(mLbl.Text)	
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub GetCanvas As Canvas
	Return cvs
End Sub

public Sub GetView As View
	Return mLbl
End Sub

'Sets, gets the text
Public Sub setText(value As String)
	mLbl.Text = value
	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
	Dim size As Float
	For size = 2 To 80
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mLbl.TextSize = size
End Sub

Public Sub getText As String
	Return mLbl.Text
End Sub

'returns true if the size is too large
Private Sub CheckSize(size As Float, MultipleLines As Boolean) As Boolean
	Try
		
	mLbl.TextSize = size
	If MultipleLines Then
		Return su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
	Else
		Return cvs.MeasureStringWidth(mLbl.Text, mLbl.Typeface, size) > mLbl.Width Or _
			su.MeasureMultilineTextHeight(mLbl, mLbl.Text) > mLbl.Height
		End If
	Catch
		LogColor("AutoTextSizeLabel - CHECKSIZE " & LastException, Colors.red)
		Return True
	End Try
	
End Sub

Private Sub mEdt_TextChanged (Old As String, New As String)
	Dim multipleLines As Boolean = mLbl.Text.Contains(CRLF)
	Dim size As Float
	For size = 2 To 80
		If CheckSize(size, multipleLines) Then Exit
	Next
	size = size - 0.5
	If CheckSize(size, multipleLines) Then size = size - 0.5
	mLbl.TextSize = size
	
	If SubExists(CallBack, EventName & "_TextChanged") Then
		CallSub3(CallBack, EventName & "_TextChanged", Old, New)
	End If
End Sub

'Sets, gets the Left property
Public Sub setLeft(Left As Int)
	mLeft = Left
	mBase.Left = Left
End Sub

Public Sub getLeft As Int
	Return mLeft
End Sub

'Sets, gets the Top property
Public Sub setTop(Top As Int)
	mTop = Top
	mBase.Top = Top
End Sub

Public Sub getTop As Int
	Return mTop
End Sub

'Sets, gets the Width property
Public Sub setWidth(Width As Int)
	mWidth = Width
	mBase.Width = Width
	setText(mLbl.Text)
End Sub

Public Sub getWidth As Int
	Return mWidth
End Sub

'Sets, gets the Height property
Public Sub setHeight(Height As Int)
	mHeight = Height
	mBase.Height = Height
	setText(mLbl.Text)
End Sub

Public Sub getHeight As Int
	Return mHeight
End Sub

Public Sub setTextColor(Color As Int)
	mLbl.TextColor = Color
End Sub

Public Sub setGravity(GR As Int)
	mLbl.gravity = GR
End Sub

Public Sub setTypeFace(TF As Typeface)
	mLbl.Typeface = TF
End Sub

Public Sub setBackGround(BG As ColorDrawable)
	mLbl.Background = BG
End Sub

Private Sub p_LongClick
   CallSub(CallBack, EventName & "_LongClick")
End Sub

Private Sub p_Click
   CallSub(CallBack, EventName & "_Click")
End Sub

public Sub setEnabled(Value As Boolean)
	mBase.Enabled = Value
End Sub

public Sub setVisible(Value As Boolean)
	mBase.Visible = Value
End Sub